/*
* $Id: psp2chImageView.c 150 2008-08-29 05:55:20Z bird_may_nike $
*/

#include "FreezeViewer.h"
#include "psp2ch.h"
#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <time.h>
#include <setjmp.h> /* setjmp()/longjmp() */
#include <jpeglib.h>
#include <png.h>
#include <gif_lib.h>
#include <pspgu.h>
#include <pspdisplay.h>
#include <psprtc.h>
#include "fvDraw.h"
#include "psp2chImageView.h"
#include "psp2chImageReader.h" /* add for read from memory */
#include "charConv.h"
#include "psp2chError.h"
#include "dialog.h"

#define EX_MEMORRY			(0x0a000000)
#define LIMIT_WIDTH			(1024)				// 摜̍ő\WIDTH
#define PNG_BYTES_TO_CHECK	(8)					// PNG̐擪wb_TCY
#define GIF_FRAME_MAX		(100)				// Aj[VGIFňő摜
#define BUF_WIDTH			(512)
#define BUF_HEIGHT			(512)

extern S_2CH s2ch; //psp2ch.c

//----- \ ----

typedef struct {												// gifp
	double	startX;
	double	startY;
	int		width2;
	int		height2;
	double	thumb;
} strPicView;

typedef struct {												// TlCǗp
	char			*path;										// TlCt@C
	ScePspDateTime	time;										// 摜̃^CX^v
} strThumb;

typedef struct tex
{
	int w;
	int h;
	int tb;
} TEX;

struct Vertex
{
	unsigned short u, v;
	unsigned char color;
	short x, y, z;
};

//----- vg^Cv -----

METHODDEF(void) my_error_exit(j_common_ptr cinfo);

int makedir (char *newdir);										// unzip/miniunz.c


//==============================================================
// G[
//--------------------------------------------------------------

//----- jpegG[[` -----

METHODDEF(void) my_error_exit(j_common_ptr cinfo)
{
	char buffer[JMSG_LENGTH_MAX];

	my_error_ptr err = (my_error_ptr)cinfo->err;
	(*cinfo->err->format_message) (cinfo, buffer);
	//psp2chErrorDialog(0, "%s", buffer);
	longjmp(err->setjmp_buffer, 1);
}

//----- PNGG[[` -----

static void myPngError(png_structp png_ptr,png_const_charp message)
{
	//psp2chErrorDialog(0, "%s", message);
	longjmp(png_ptr->jmpbuf, 1);
}


//==============================================================
// `͈͂gk
//--------------------------------------------------------------

#define SLICE_SIZE 64
static void blt(void *src, TEX *tex, int sw, int sh, int dw, int dh)
{
	int i, j, dy;
	struct Vertex *vertices;
	int* p = src;

	dy = BUF_HEIGHT * dw / sw;

	sceKernelDcacheWritebackInvalidateAll();					// LbVNA
	guStart();
	sceGuScissor(0, 0, SCREEN_WIDTH, SCREEN_HEIGHT);
	sceGuClearColor(s2ch.BakCor);
	sceGuClearDepth(0);
	sceGuClear(GU_COLOR_BUFFER_BIT | GU_DEPTH_BUFFER_BIT);
	sceGuTexMode(GU_PSM_8888, 0, 0, GU_FALSE);
	sceGuTexFunc(GU_TFX_REPLACE, GU_TCC_RGBA);
	sceGuTexWrap(GU_CLAMP, GU_CLAMP);
	if (sw == dw)
		sceGuTexFilter(GU_NEAREST, GU_NEAREST);
	else
		sceGuTexFilter(GU_LINEAR, GU_LINEAR);
	i = 0;
	/* textureSLICE_SIZE * BUF_HEIGHTɐ؂ă[v */
	while (sh > BUF_HEIGHT)
	{
		for (j = 0; (j + SLICE_SIZE) < sw; j = j + SLICE_SIZE)
		{
			sceGuTexImage(0, tex->w, tex->h, tex->tb, p + j);
			vertices = (struct Vertex *)sceGuGetMemory(2 * sizeof(struct Vertex));
			vertices[0].u = 0;
			vertices[0].v = 0;
			vertices[0].x = j * dw / sw;
			vertices[0].y = dy * i;
			vertices[1].u = SLICE_SIZE;
			vertices[1].v = BUF_HEIGHT;
			vertices[1].x = (j + SLICE_SIZE) * dw / sw;
			vertices[1].y = dy * (i + 1);
			sceGuDrawArray(GU_SPRITES, GU_TEXTURE_16BIT | GU_COLOR_4444 | GU_VERTEX_16BIT | GU_TRANSFORM_2D, 2, NULL, vertices);
		}
		if (j < sw)
		{
			sceGuTexImage(0, tex->w, tex->h, tex->tb, p + j);
			vertices = (struct Vertex *)sceGuGetMemory(2 * sizeof(struct Vertex));
			vertices[0].u = 0;
			vertices[0].v = 0;
			vertices[0].x = j * dw / sw;
			vertices[0].y = dy * i;
			vertices[1].u = sw - j;
			vertices[1].v = BUF_HEIGHT;
			vertices[1].x = dw;
			vertices[1].y = dy * (i + 1);
			sceGuDrawArray(GU_SPRITES, GU_TEXTURE_16BIT | GU_COLOR_4444 | GU_VERTEX_16BIT | GU_TRANSFORM_2D, 2, NULL, vertices);
		}
		sh -= BUF_HEIGHT;
		p += tex->tb * BUF_HEIGHT;
		i++;
	}
	for (j = 0; (j + SLICE_SIZE) < sw; j = j + SLICE_SIZE)
	{
		sceGuTexImage(0, tex->w, tex->h, tex->tb, p + j);
		vertices = (struct Vertex *)sceGuGetMemory(2 * sizeof(struct Vertex));
		vertices[0].u = 0;
		vertices[0].v = 0;
		vertices[0].x = j * dw / sw;
		vertices[0].y = dy * i;
		vertices[1].u = SLICE_SIZE;
		vertices[1].v = sh;
		vertices[1].x = (j + SLICE_SIZE) * dw / sw;
		vertices[1].y = dh;
		sceGuDrawArray(GU_SPRITES, GU_TEXTURE_16BIT | GU_COLOR_4444 | GU_VERTEX_16BIT | GU_TRANSFORM_2D, 2, NULL, vertices);
	}
	if (j < sw)
	{
		sceGuTexImage(0, tex->w, tex->h, tex->tb, p + j);
		vertices = (struct Vertex *)sceGuGetMemory(2 * sizeof(struct Vertex));
		vertices[0].u = 0;
		vertices[0].v = 0;
		vertices[0].x = j * dw / sw;
		vertices[0].y = dy * i;
		vertices[1].u = sw - j;
		vertices[1].v = sh;
		vertices[1].x = dw;
		vertices[1].y = dh;
		sceGuDrawArray(GU_SPRITES, GU_TEXTURE_16BIT | GU_COLOR_4444 | GU_VERTEX_16BIT | GU_TRANSFORM_2D, 2, NULL, vertices);
	}
	sceGuFinish();
	sceGuSync(GU_SYNC_FINISH, GU_SYNC_WHAT_DONE);
}

//==============================================================
// TlC̐
//--------------------------------------------------------------
// WJꂽ摜C[WTHUMBXSIZExTHUMBYSIZE͈͓̔Ɏ܂悤ɏkA
// TlCtH_֕ۑB
// TlCɎ擾Ăꍇł摜̃^CX^vɕω
// ꍇ͍ĐsB
// TlCt@Cɂ͉摜ɊւꏏɋL^܂B
//--------------------------------------------------------------

static void makeThumb(FileData *FData, int* img[], TEX tex, int width, int height, strThumb thumbData)
{
	SceUID			fd;
	DrawImg			*pic;
	unsigned short	*buf;
	char	*p, path[1024];
	int		width2, height2, bufsize;
	double	thumb;

	if (FData->thumb && (FData->thumbTime.year==thumbData.time.year &&
	                     FData->thumbTime.month==thumbData.time.month &&
	                     FData->thumbTime.day==thumbData.time.day &&
	                     FData->thumbTime.hour==thumbData.time.hour &&
	                     FData->thumbTime.minute==thumbData.time.minute &&
	                     FData->thumbTime.second==thumbData.time.second) ) {
		return;													// TlCƉ摜̃^CX^vȂ珈Ȃ
	}

	thumb = (double)width / (double)THUMBXSIZE;					// ɍ킹ꍇ̔{
	if (height/thumb > THUMBYSIZE) {							// cTHUMBYSIZE𒴂ȂC
		thumb = (double)height / (double)THUMBYSIZE;
		if (thumb < 1.0f) thumb = 1.0f;							// TlCTCYȉ̉摜͌
	}
	width2 = width / thumb;
	height2 = height / thumb;
	if (FData->thumb) DrawImgFree(FData->thumb);
	pic = DrawImgCreate( width2, height2 );
	if (pic) {
		blt( img[0], &tex, width, height, width2, height2 );	// TlC
		BoxCopy2( pic, 0, 0 );									// TlC荞
		if (!FData->thumb) FData->thumb = pic;
		FData->xSize = width;
		FData->ySize = height;
		FData->thumbTime.year = thumbData.time.year;
		FData->thumbTime.month = thumbData.time.month;
		FData->thumbTime.day = thumbData.time.day;
		FData->thumbTime.hour = thumbData.time.hour;
		FData->thumbTime.minute = thumbData.time.minute;
		FData->thumbTime.second = thumbData.time.second;
		bufsize = 32 + malloc_usable_size(pic->data);
		buf = (unsigned short*) memalign( 16, bufsize );
		if (buf) {
			buf[0] = THUMBID | 0x0100;
			buf[1] = width2;									// TlCXTCY
			buf[2] = height2;									// TlCYTCY
			buf[3] = thumbData.time.year;						// 摜̃^CX^v
			buf[4] = thumbData.time.month;
			buf[5] = thumbData.time.day;
			buf[6] = thumbData.time.hour;
			buf[7] = thumbData.time.minute;
			buf[8] = thumbData.time.second;
			buf[9] = FData->xSize;								// 摜̃TCY
			buf[10] = FData->ySize;
			buf[11] = 0;
			buf[12] = 0;
			buf[13] = 0;
			buf[14] = 0;
			buf[15] = 0;
			memcpy( (char*)&buf[16], pic->data, malloc_usable_size(pic->data) );
			p = strrchr( thumbData.path, '/' );
			if (p) {
				strncpy( path, thumbData.path, p - thumbData.path );
				path[p - thumbData.path] = '\0';
				if (makedir(path)) {							// wtH_̐ɐ
					fd = sceIoOpen( thumbData.path, PSP_O_WRONLY | PSP_O_CREAT | PSP_O_TRUNC, FILE_PARMISSION );
					sceIoWrite(fd, buf, bufsize);
					sceIoClose(fd);
				}
			}
			free(buf);
		}
	}
}

//==============================================================
// Î~摜̕\C
//--------------------------------------------------------------

static int psp2chImageViewer(int* img[], int width, int height, int *menu, int *thumbFlag, int shift, char *info, FileData *FData, strThumb thumbData)
{
	int		startX, startY, width2, height2;
	double	thumb;
	int		padX, padY;
	int		ret = COMPLETE;
	double	thumbW, thumbH;
	int		imgWH, imgHW, sx, sy;
	TEX		tex;
	int		**imgBuf = NULL;
	int		*tmpbuf = NULL;
	int		originalWidth = width;

	// Gu]̂1s16oCgEɂ낦
	tex.tb = (width + 15) & 0xFFFFFFF0;
	tex.w = BUF_WIDTH;
	tex.h = BUF_HEIGHT;

	// ̑傫摜͏k
	if (originalWidth > LIMIT_WIDTH)
	{
		int i, j, k;
		int mip = originalWidth >> 10;
		mip++;
		
		i =  height / mip;
		imgBuf = memalign(16, sizeof(int *) * i);
		if (!imgBuf)
		{
			return MEM_ERR;
		}
		tmpbuf = memalign(16, sizeof(int) * LIMIT_WIDTH * i);
		if (!tmpbuf)
		{
			free(imgBuf);
			return MEM_ERR;
		}
		for (j = 0; j < i; j++)
		{
			imgBuf[j] = tmpbuf + (LIMIT_WIDTH * j);
			for (k = 0; k < width; k += mip)
			{
				imgBuf[j][k / mip] = img[j * mip][k];
			}
		}
		width /= mip;
		height /= mip;
		tex.tb = LIMIT_WIDTH;
		img = imgBuf;
	}
	thumbW = (double)width / SCREEN_WIDTH;						// ʕɍ킹邽߂̊gk
	imgWH = height / thumbW;									// ʕɍ킹Ƃ̉摜
	thumbH = (double)height / SCREEN_HEIGHT;					// ʍɂ킹邽߂̊gk
	imgHW = width / thumbH;										// ʍɂ킹Ƃ̉摜

	makeThumb( FData, img, tex, width, height, thumbData );		// TlC摜Ȃ琶

	startX = 0;
	startY = 0;
	switch (*thumbFlag){
	case 0:
		thumb = 1.0;
		width2 = width;
		height2 = height;
		break;
	case 1:
		thumb = thumbW;
		width2 = SCREEN_WIDTH;
		height2 = imgWH;
		break;
	case 2:
		thumb = thumbH;
		width2 = imgHW;
		height2 = SCREEN_HEIGHT;
		break;
	default:
		if (width / height >= 1.78) {
			thumb = thumbW;
			width2 = SCREEN_WIDTH;
			height2 = imgWH;
			*thumbFlag = 1;
		}
		else {
			thumb = thumbH;
			width2 = imgHW;
			height2 = SCREEN_HEIGHT;
			*thumbFlag = 2;
		}
	}

	// 摜\C[v
	while (!gExitRequest)
	{
		if(sceCtrlPeekBufferPositive(&s2ch.pad, 1))
		{
			if (s2ch.pad.Buttons != s2ch.oldPad.Buttons)
			{
				s2ch.oldPad = s2ch.pad;
				if(s2ch.pad.Buttons & PSP_CTRL_CIRCLE)			// g嗦
				{
					(*thumbFlag)++;
					if (*thumbFlag > 2)
					{
						*thumbFlag = 0;
					}
					if (*thumbFlag == 1)
					{
						thumb = thumbW;
						width2 = SCREEN_WIDTH;
						height2 = imgWH;
					}
					else if (*thumbFlag == 2)
					{
						thumb = thumbH;
						width2 = imgHW;
						height2 = SCREEN_HEIGHT;
					}
					else
					{
						thumb = 1.0;
						width2 = width;
						height2 = height;
					}
					startX = 0;
					startY = 0;
				}
				else if(s2ch.pad.Buttons & PSP_CTRL_CROSS)		// \I
				{
					ret = SAVE_ERR;
				}
				else if(s2ch.pad.Buttons & PSP_CTRL_TRIANGLE)	// j[ON/OFF
				{
					(*menu) ^= 0x01;
				}
				else if(s2ch.pad.Buttons & PSP_CTRL_SELECT)		// vpeB
				{
					(*menu) ^= 0x02;
				}
				else if(s2ch.pad.Buttons & PSP_CTRL_SQUARE)		// 폜
				{
//					break;
				}
				else if(s2ch.pad.Buttons & PSP_CTRL_RTRIGGER && shift){	// 摜p
					break;
				}
				else if(s2ch.pad.Buttons & PSP_CTRL_LTRIGGER && shift){	// 摜p
					break;
				}
			}
			if(s2ch.pad.Buttons & PSP_CTRL_UP)
			{
				startY -= 2 * thumb;
			}
			if(s2ch.pad.Buttons & PSP_CTRL_DOWN)
			{
				startY += 2 * thumb;
			}
			if(s2ch.pad.Buttons & PSP_CTRL_LEFT)
			{
				startX -= 2 * thumb;
			}
			if(s2ch.pad.Buttons & PSP_CTRL_RIGHT)
			{
				startX += 2 * thumb;
			}
			padX = s2ch.pad.Lx - 127;
			padY = s2ch.pad.Ly - 127;
			if ((padX < -s2ch.cfg.padCutoff) || (padX > s2ch.cfg.padCutoff))
			{
				startX += (padX)/8 * thumb;
			}
			if ((padY < -s2ch.cfg.padCutoff) || (padY > s2ch.cfg.padCutoff))
			{
				startY += (padY)/8 * thumb;
			}
		}
		// width : 摜
		// height : 摜
		// sx.sy : 摜ɂ\Jnʒu
		// width2 : \摜
		// height2 : \摜
		// startX.startY : \摜ɂ\Jnʒu
		if (startX >= width2 - SCREEN_WIDTH)
		{
			startX = width2 - SCREEN_WIDTH;
		}
		if (startY >= height2 - SCREEN_HEIGHT)
		{
			startY = height2 - SCREEN_HEIGHT;
		}
		if (startX < 0)
		{
			startX = 0;
		}
		if (startY < 0)
		{
			startY = 0;
		}
		sx = thumb * startX;
		sy = thumb * startY;
		if (originalWidth > LIMIT_WIDTH)
		{
			blt(img[sy] + sx, &tex, width - sx, height - sy, width2 - startX, height2 - startY);
		}
		else
		{
			blt(img[sy] + sx, &tex, width - sx, height - sy, width2 - startX, height2 - startY);
		}
		guStart();
		if (((*menu) & 0x01) && (ret != SAVE_ERR))
		{
			if_printSjis( 10, 270, "  : gk  ~ : ߂   : j[IEIt  kq : 摜", 0.8f, 0xFFFFFF, 0x101010, 0.7f );
		}
		if (((*menu) & 0x02) && info && (ret != SAVE_ERR)){
			char *str, msg[256], buf[32];
			strcpy( msg, info );
			sprintf( buf, "\n{ %f", 1/thumb );
			strcat( msg, buf );
			str = msg;
			if_printSjis( 10, 48, str, 0.7f, 0xFFFFFF, 0x101010, 0.7f );
		}
		sceGuFinish();
		sceDisplayWaitVblankStart();
		flipScreen(0);

		if (ret == SAVE_ERR) break;
	}

	free(tmpbuf);
	free(imgBuf);
	return 0;
}

//==============================================================
// jpegt@Cǂݍ32rbgRGBAɕϊ
//--------------------------------------------------------------

int psp2chImageViewJpeg(const char* data, unsigned long length, int *menu, int *thumbFlag, int shift, char *info, FileData *FData, strThumb thumbData)
{
	JSAMPARRAY img = NULL;
	JSAMPROW buf = NULL, imgbuf = NULL;
	unsigned long width, height, i;
	int ret = COMPLETE;
	struct jpeg_decompress_struct cinfo;
	struct my_error_mgr jerr;	/* add */
	cinfo.err = jpeg_std_error(&jerr.pub);

	if ((u8)data[0] != 0xFF || (u8)data[1] != 0xD8)
	{
		return HEAD_ERR;
	}
	/* add */
	jerr.pub.error_exit = my_error_exit;
	if(setjmp(jerr.setjmp_buffer)) /* error̃Wv */
	{
		ret = LIB_ERR;
		goto jpeg_Error;
	}
	// LJn
	jpeg_create_decompress(&cinfo);
	jpeg_memory_src(&cinfo, (void*)data, length);
	jpeg_read_header(&cinfo, TRUE);
	if (info){
		sprintf(info, "t@CTCY %dKB\n摜TCY X=%d Y=%d\nJ[ %d",
		              (int)length/1024, cinfo.image_width, cinfo.image_height, cinfo.out_color_components);
	}
	// 傫ꍇɂŏk(̂)
	while ((cinfo.image_width / cinfo.scale_denom) > LIMIT_WIDTH)
	{
		cinfo.scale_denom += cinfo.scale_denom;
	}
	jpeg_calc_output_dimensions(&cinfo);
	jpeg_start_decompress(&cinfo);
	// Gu]̂1s16oCgEɂ낦
	width = (cinfo.output_width + 15) & 0xFFFFFFF0;
	height = cinfo.output_height;
	img = memalign(16, sizeof(JSAMPROW) * height);
	if (!img)
	{
		ret = MEM_ERR;
		goto jpeg_Error;
	}
	buf = memalign(16, sizeof(JSAMPLE) * cinfo.output_components * width);
	if (!buf)
	{
		ret = MEM_ERR;
		goto jpeg_Error;
	}
	imgbuf = memalign(16, sizeof(JSAMPLE) * 4 * width * height);
	if (!imgbuf)
	{
		ret = MEM_ERR;
		goto jpeg_Error;
	}
	for (i = 0; i < height; i++ )
	{
		img[i] = &imgbuf[i * width * 4];
	}
	// RGBJ[RGBA
	if (cinfo.out_color_components == 3)
	{
		while(cinfo.output_scanline < cinfo.output_height)
		{
			jpeg_read_scanlines(&cinfo, &buf, 1);
			for (i = 0; i < cinfo.output_width; i++)
			{
				img[cinfo.output_scanline-1][i * 4 + 0] = buf[i * 3 + 0];
				img[cinfo.output_scanline-1][i * 4 + 1] = buf[i * 3 + 1];
				img[cinfo.output_scanline-1][i * 4 + 2] = buf[i * 3 + 2];
				img[cinfo.output_scanline-1][i * 4 + 3] = 0xFF;
			}
			sceKernelDelayThread(50);							// 0.05ms~iBGMXbh쓮pj
		}
	}
	// O[XP[RGBA
	else if (cinfo.out_color_components == 1)
	{
		while(cinfo.output_scanline < cinfo.output_height)
		{
			jpeg_read_scanlines(&cinfo, &buf, 1);
			for (i = 0; i < cinfo.output_width; i++)
			{
				img[cinfo.output_scanline-1][i * 4 + 0] = buf[i];
				img[cinfo.output_scanline-1][i * 4 + 1] = buf[i];
				img[cinfo.output_scanline-1][i * 4 + 2] = buf[i];
				img[cinfo.output_scanline-1][i * 4 + 3] = 0xFF;
			}
			sceKernelDelayThread(50);							// 0.05ms~iBGMXbh쓮pj
		}
	}
	else
	{
		ret = SUP_ERR;
		goto jpeg_Error;
	}
	jpeg_finish_decompress(&cinfo);
	// \
	ret = psp2chImageViewer((int**)img, cinfo.output_width, height, menu, thumbFlag, shift, info, FData, thumbData);
jpeg_Error:
	// I
	jpeg_destroy_decompress(&cinfo);
	if(imgbuf)
		free(imgbuf);
	if(buf)
		free(buf);
	if(img)
		free(img);
	return ret;
}

//==============================================================
// PNGt@Cǂݍ32rbgRGBAɕϊ
//--------------------------------------------------------------

int psp2chImageViewPng(const char* data, unsigned long length, int *menu, int *thumbFlag, int shift, char *info, FileData *FData, strThumb thumbData)
{
	my_img_buffer png_buf;
	png_structp png_ptr;
	png_infop info_ptr;
	png_infop end_info;
	unsigned long width, height, width2, i;
	int bit_depth, color_type, interlace_type, ret = COMPLETE;
	png_bytepp img = NULL;
	png_bytep imgbuf = NULL;

	png_buf.data = (unsigned char*)data;
	png_buf.length = length;
	// PNG`FbN
	if (png_sig_cmp((png_bytep)png_buf.data, 0, PNG_BYTES_TO_CHECK) != 0)
	{
		return HEAD_ERR;
	}
	png_buf.offset = PNG_BYTES_TO_CHECK;
	png_buf.data += PNG_BYTES_TO_CHECK;
	png_ptr = png_create_read_struct(PNG_LIBPNG_VER_STRING, NULL, NULL, NULL);
	info_ptr = png_create_info_struct(png_ptr);
	end_info = png_create_info_struct(png_ptr);
	//G[nh
	if (setjmp(png_ptr->jmpbuf))
	{
		ret = LIB_ERR;
		goto png_Error;
	}
	// IOύX
	png_set_read_fn(png_ptr, (void*)&png_buf, (png_rw_ptr)png_memread_func);
	png_set_error_fn(png_ptr, NULL, myPngError, NULL);
	png_set_sig_bytes(png_ptr, PNG_BYTES_TO_CHECK);
	png_read_info(png_ptr, info_ptr);
	png_get_IHDR(png_ptr, info_ptr, &width, &height, &bit_depth, &color_type, &interlace_type, NULL, NULL);
	if (info){
		sprintf(info, "t@CTCY %dKB\n摜TCY X=%d Y=%d\nJ[ %X\nrbg %d\nC^[[X %d",
		              (int)length/1024, (int)width, (int)height, color_type, bit_depth, interlace_type);
	}
	//pbgn->RGBnɊg
	if (color_type == PNG_COLOR_TYPE_PALETTE ||
		(color_type == PNG_COLOR_TYPE_GRAY && bit_depth < 8) ||
		png_get_valid(png_ptr, info_ptr, PNG_INFO_tRNS))
	{
		png_set_expand(png_ptr);
	}
	//16rbg->8rbgɗƂ
	if (bit_depth > 8)
	{
		png_set_strip_16(png_ptr);
	}
	//O[XP[->RGBɊg
	if (color_type==PNG_COLOR_TYPE_GRAY || color_type==PNG_COLOR_TYPE_GRAY_ALPHA)
	{
		png_set_gray_to_rgb(png_ptr);
	}
	if (color_type != PNG_COLOR_TYPE_RGB_ALPHA && color_type!=PNG_COLOR_TYPE_GRAY_ALPHA)
	{
		png_set_add_alpha(png_ptr, 0xFFFF, PNG_FILLER_AFTER);
	}
	png_read_update_info(png_ptr, info_ptr);
	// Gu]̂1s16oCgEɂ낦
	width2 = (width + 15) & 0xFFFFFFF0;
	img = memalign(16, height * sizeof(png_bytep));
	if (!img)
	{
		ret = MEM_ERR;
		goto png_Error;
	}
	// change 擾TCYύX b菈u
	imgbuf = memalign(16, sizeof(unsigned char) * 4 * width2 * height);
	if (!imgbuf)
	{
		ret = MEM_ERR;
		goto png_Error;
	}
	for (i = 0; i < height; i++)
	{
		img[i] = &imgbuf[i * width2 * 4];
	}
	png_read_image(png_ptr, img);
	png_read_end(png_ptr, end_info);
	ret = psp2chImageViewer((int**)img, (int)width, (int)height, menu, thumbFlag, shift, info, FData, thumbData);
png_Error:
	png_destroy_read_struct(&png_ptr, &info_ptr, &end_info);
	if(imgbuf)
		free(imgbuf);
	if(img)
		free(img);
	return ret;
}

//==============================================================
// BMPt@Cǂݍ32rbgRGBAɕϊ
//--------------------------------------------------------------

int psp2chImageViewBmp(char* data, unsigned long length,int *menu, int *thumbFlag, int shift, char *info, FileData *FData, strThumb thumbData)
{
	char* bmp_data;
	int i, j, y, width, height, len, ret = COMPLETE;
	BITMAPFILEHEADER bf;
	BITMAPINFOHEADER bi;
	unsigned char **img = NULL, *imgbuf = NULL, *buf = NULL;
	bmp_data = data;
	memcpy(&bf, bmp_data, sizeof(BITMAPFILEHEADER));
	bmp_data += sizeof(BITMAPFILEHEADER);
	// BITMAP F "BM"
	if (memcmp(bf.bfType, "BM", 2) != 0)
	{
		return HEAD_ERR;
	}
	memcpy(&bi, bmp_data, sizeof(BITMAPINFOHEADER));
	bmp_data += sizeof(BITMAPINFOHEADER);
	if (info){
		sprintf(info, "t@CTCY %dKB\n摜TCY X=%d Y=%d\nJ[ %d\nk %d",
		              (int)length/1024, (int)bi.biWidth, (int)bi.biHeight, bi.biBitCount, (int)bi.biCompression);
	}
	// 񈳏k̂
	if (bi.biCompression)
	{
		return SUP_ERR;
	}
	if (bi.biHeight < 0)
	{
		height = -bi.biHeight;
	}
	else
	{
		height = bi.biHeight;
	}
	// Gu]̂1s16oCgEɂ낦
	width = (bi.biWidth + 15) & 0xFFFFFFF0;
	len = bi.biWidth * bi.biBitCount / 8;
	len += (4 - (len & 3)) & 3;
	img = memalign(16, sizeof(unsigned char*) * height);
	if (!img)
	{
		ret = MEM_ERR;
		goto bmp_Error;
	}
	buf = memalign(16, sizeof(unsigned char) * len);
	if (!buf)
	{
		ret = MEM_ERR;
		goto bmp_Error;
	};
	imgbuf = memalign(16, sizeof(unsigned char) * 4 * width * height);
	if (!imgbuf)
	{
		ret = MEM_ERR;
		goto bmp_Error;
	}
	for (i = 0; i < height; i++ )
	{
		img[i] = &imgbuf[i * width * 4];
	}
	bmp_data = data + bf.bfOffBits;
	// 24rbgBMPRGBA
	if (bi.biBitCount == 24)
	{
		for (j = 0; j < height; j++)
		{
			if (bi.biHeight < 0)
			{
				y = j;
			}
			else
			{
				y = height - j - 1;
			}
			memcpy(buf, bmp_data, len);
			bmp_data += len;
			for (i = 0; i < bi.biWidth; i++)
			{
				img[y][i * 4 + 0] = buf[i * 3 + 2];
				img[y][i * 4 + 1] = buf[i * 3 + 1];
				img[y][i * 4 + 2] = buf[i * 3 + 0];
				img[y][i * 4 + 3] = 0xFF;
			}
			sceKernelDelayThread(50);							// 0.05ms~iBGMXbh쓮pj
		}
	}
	// 32rbgBMPRGBA
	else if (bi.biBitCount == 32)
	{
		for (j = 0; j <height; j++)
		{
			if (bi.biHeight < 0)
			{
				y = j;
			}
			else
			{
				y = height - j - 1;
			}
			memcpy(buf, bmp_data, len);
			bmp_data += len;
			for (i = 0; i < bi.biWidth; i++)
			{
				img[y][i * 4 + 0] = buf[i * 4 + 2];
				img[y][i * 4 + 1] = buf[i * 4 + 1];
				img[y][i * 4 + 2] = buf[i * 4 + 0];
				img[y][i * 4 + 3] = 0xFF;
			}
			sceKernelDelayThread(50);							// 0.05ms~iBGMXbh쓮pj
		}
	}
	// Ή
	else
	{
		ret = SUP_ERR;
		goto bmp_Error;
	}
	ret = psp2chImageViewer((int**)img, bi.biWidth, height, menu, thumbFlag, shift, info, FData, thumbData);
bmp_Error:
	if(imgbuf)
		free(imgbuf);
	if(buf)
		free(buf);
	if(img)
		free(img);
	return ret;
}

//==============================================================
// Aj[Vgifp̕\C
//--------------------------------------------------------------

static int psp2chImageViewer2(int* img[], int width, int height, int *menu, int *thumbFlag, int *reset, int shift, strPicView *pv,char *info, FileData *FData, strThumb thumbData)
{
	int		padX, padY;
	int		ret = 10;
	double	thumbW, thumbH;
	int		imgWH, imgHW, sx, sy;
	TEX		tex;
	int		**imgBuf = NULL;
	int*	tmpbuf = NULL;
	int		originalWidth = width;

	// Gu]̂1s16oCgEɂ낦
	tex.tb = (width + 15) & 0xFFFFFFF0;
	tex.w = BUF_WIDTH;
	tex.h = BUF_HEIGHT;
	// ̑傫摜͏k
	if (originalWidth > LIMIT_WIDTH)
	{
		int i, j, k;
		int mip = originalWidth >> 10;
		mip++;
		
		i =  height / mip;
		imgBuf = memalign(16, sizeof(int *) * i);
		if (!imgBuf)
		{
			return MEM_ERR;
		}
		tmpbuf = memalign(16, sizeof(int) * LIMIT_WIDTH * i);
		if (!tmpbuf)
		{
			free(imgBuf);
			return MEM_ERR;
		}
		for (j = 0; j < i; j++)
		{
			imgBuf[j] = tmpbuf + (LIMIT_WIDTH * j);
			for (k = 0; k < width; k += mip)
			{
				imgBuf[j][k / mip] = img[j * mip][k];
			}
		}
		width /= mip;
		height /= mip;
		tex.tb = LIMIT_WIDTH;
		img = imgBuf;
	}

	makeThumb( FData, img, tex, width, height, thumbData );		// TlC摜Ȃ琶

	thumbW = (double)width / SCREEN_WIDTH;						// ʕɍ킹邽߂̊gk
	imgWH = height / thumbW;									// ʕɍ킹Ƃ̉摜
	thumbH = (double)height / SCREEN_HEIGHT;					// ʍɂ킹邽߂̊gk
	imgHW = width / thumbH;										// ʍɂ킹Ƃ̉摜
	// ϐ̃Zbg
	if (*reset){
		*reset = 0;
		pv->startX = 0;
		pv->startY = 0;
		switch (*thumbFlag){
		case 0:
			pv->thumb = 1.0;
			pv->width2 = width;
			pv->height2 = height;
			break;
		case 1:
			pv->thumb = thumbW;
			pv->width2 = SCREEN_WIDTH;
			pv->height2 = imgWH;
			break;
		case 2:
			pv->thumb = thumbH;
			pv->width2 = imgHW;
			pv->height2 = SCREEN_HEIGHT;
			break;
		default:
			if (width / height >= 1.78) {
				pv->thumb = thumbW;
				pv->width2 = SCREEN_WIDTH;
				pv->height2 = imgWH;
				*thumbFlag = 1;
			}
			else {
				pv->thumb = thumbH;
				pv->width2 = imgHW;
				pv->height2 = SCREEN_HEIGHT;
				*thumbFlag = 2;
			}
		}
	}

	if(sceCtrlPeekBufferPositive(&s2ch.pad, 1))
	{
		if (s2ch.pad.Buttons != s2ch.oldPad.Buttons)
		{
			s2ch.oldPad = s2ch.pad;
			if(s2ch.pad.Buttons & PSP_CTRL_CIRCLE)
			{
				(*thumbFlag)++;
				if (*thumbFlag > 2)
				{
					*thumbFlag = 0;
				}
				if (*thumbFlag == 1)
				{
					pv->thumb = thumbW;
					pv->width2 = SCREEN_WIDTH;
					pv->height2 = imgWH;
				}
				else if (*thumbFlag == 2)
				{
					pv->thumb = thumbH;
					pv->width2 = imgHW;
					pv->height2 = SCREEN_HEIGHT;
				}
				else
				{
					pv->thumb = 1.0;
					pv->width2 = width;
					pv->height2 = height;
				}
				pv->startX = 0;
				pv->startY = 0;
			}
			else if(s2ch.pad.Buttons & PSP_CTRL_CROSS)
			{
				ret = COMPLETE;
			}
			else if(s2ch.pad.Buttons & PSP_CTRL_TRIANGLE)
			{
				(*menu) ^= 0x01;
			}
			else if(s2ch.pad.Buttons & PSP_CTRL_SELECT)
			{
				(*menu) ^= 0x02;
			}
			else if(s2ch.pad.Buttons & PSP_CTRL_SQUARE)
			{
//				ret = COMPLETE;
			}
			else if(s2ch.pad.Buttons & PSP_CTRL_RTRIGGER && shift){	// 摜p
				ret = COMPLETE;
			}
			else if(s2ch.pad.Buttons & PSP_CTRL_LTRIGGER && shift){	// 摜p
				ret = COMPLETE;
			}
		}
		if(s2ch.pad.Buttons & PSP_CTRL_UP)
		{
			pv->startY -= 2 * pv->thumb;
		}
		if(s2ch.pad.Buttons & PSP_CTRL_DOWN)
		{
			pv->startY += 2 * pv->thumb;
		}
		if(s2ch.pad.Buttons & PSP_CTRL_LEFT)
		{
			pv->startX -= 2 * pv->thumb;
		}
		if(s2ch.pad.Buttons & PSP_CTRL_RIGHT)
		{
			pv->startX += 2 * pv->thumb;
		}
		padX = s2ch.pad.Lx - 127;
		padY = s2ch.pad.Ly - 127;
		if ((padX < -s2ch.cfg.padCutoff) || (padX > s2ch.cfg.padCutoff))
		{
			pv->startX += (padX)/8 * pv->thumb;
		}
		if ((padY < -s2ch.cfg.padCutoff) || (padY > s2ch.cfg.padCutoff))
		{
			pv->startY += (padY)/8 * pv->thumb;
		}
	}
	// width : 摜
	// height : 摜
	// sx.sy : 摜ɂ\Jnʒu
	// width2 : \摜
	// height2 : \摜
	// startX.startY : \摜ɂ\Jnʒu
	if (pv->startX >= pv->width2 - SCREEN_WIDTH)
	{
		pv->startX = pv->width2 - SCREEN_WIDTH;
	}
	if (pv->startY >= pv->height2 - SCREEN_HEIGHT)
	{
		pv->startY = pv->height2 - SCREEN_HEIGHT;
	}
	if (pv->startX < 0)
	{
		pv->startX = 0;
	}
	if (pv->startY < 0)
	{
		pv->startY = 0;
	}
	sx = pv->thumb * pv->startX;
	sy = pv->thumb * pv->startY;
	if (originalWidth > LIMIT_WIDTH)
	{
		blt(img[sy] + sx, &tex, width - sx, height - sy, pv->width2 - pv->startX, pv->height2 - pv->startY);
	}
	else
	{
		blt(img[sy] + sx, &tex, width - sx, height - sy, pv->width2 - pv->startX, pv->height2 - pv->startY);
	}
	guStart();
	if (((*menu) & 0x01) && (ret != COMPLETE))
	{
		if_printSjis( 10, 270, "  : gk  ~ : ߂   : j[IEIt  kq : 摜", 0.8f, 0xFFFFFF, 0x101010, 0.7f );
	}
	if (((*menu) & 0x02) && info && (ret != COMPLETE)){
		char *str, msg[256], buf[32];
		strcpy( msg, info );
		sprintf( buf, "\n{ %f", 1/pv->thumb );
		strcat( msg, buf );
		str = msg;
		if_printSjis( 10, 48, str, 0.7f, 0xFFFFFF, 0x101010, 0.7f );
	}
	sceGuFinish();
	sceDisplayWaitVblankStart();
	flipScreen(0);

	free(tmpbuf);
	free(imgBuf);
	return ret;
}

//==============================================================
// GIFt@Cǂݍ32rbgRGBAɕϊ
//--------------------------------------------------------------

int psp2chImageViewGif(const char* data, unsigned long length, int *menu, int *thumbFlag, int shift, char *info, FileData *FData, strThumb thumbData)
{
	int InterlacedOffset[] = { 0, 4, 2, 1 }; /* The way Interlaced image should. */
	int InterlacedJumps[] = { 8, 8, 4, 2 };	/* be read - offsets and jumps... */
	int i, j, Size, Row, Col, Width, Height, Count, ExtCode, width2, ret = COMPLETE;
	int reset, err = 0, cormap = 0;
	int frameCnt, imgCount = 0, colorCount, SHeight, SWidth;
	int transparent = -1, delaytime, ImageSize;
	unsigned int	nextTime, oldClock;
	my_img_buffer	gif_buf;
	GifFileType		*GifFile;
	GifRowType		*ScreenBuffer = NULL, ImgBuf = NULL, GifRow;
	GifRecordType	RecordType;
	GifByteType		*Extension;
	GifColorType	*ColorMapEntry;
	ColorMapObject	*ColorMap;
	unsigned char	**img = NULL, *buf = NULL, *BufferP;
	strPicView		pv;
	struct strGif{												// GIF̊et[L^C[Wobt@
		int				transparent;							// ߐF
		int				delaytime;								// t[Ԓx
		GifRowType		ImgBuf;									// pbgC[W
		GifColorType	*Colors;								// pbge[u
	} *gif = NULL;

	gif_buf.data = (unsigned char*)data;
	gif_buf.length = length;
	gif_buf.offset = 0;
	if ((GifFile = DGifOpen(&gif_buf, gif_data_read_func)) == NULL)
	{
		return LIB_ERR;
	}
	colorCount = 0;
	do {														// ȈՌ^GIF\́iDGifSlurp()ł̓̂Łj
		if(sceCtrlPeekBufferPositive(&s2ch.pad, 1)){
			if (s2ch.pad.Buttons != s2ch.oldPad.Buttons){
				s2ch.oldPad = s2ch.pad;
				if(s2ch.pad.Buttons & PSP_CTRL_CROSS){			// ~ɂ钆f
					ret = SAVE_ERR;
					err = -1;
					goto gif_Error;
				}
			}
		}
		if (DGifGetRecordType(GifFile, &RecordType) == GIF_ERROR){
			ret = LIB_ERR;
			err = -1;
			goto gif_Error;
		}
		switch (RecordType){
		case IMAGE_DESC_RECORD_TYPE:
			if (DGifGetImageDesc(GifFile) == GIF_ERROR){
				ret = LIB_ERR;
				err = -1;
				goto gif_Error;
			}
			ImageSize = GifFile->Image.Width;
			ScreenBuffer = (GifRowType *)malloc((size_t)ImageSize * sizeof(GifPixelType));
			if (ScreenBuffer == NULL) {
				ret = MEM_ERR;
				err = -1;
				goto gif_Error;
			}
			for (i=0; i<GifFile->Image.Height ;i++){			// ȂƎ̉摜ɍsȂcxȂ邩肽Ȃ̂
				if (DGifGetLine(GifFile, (GifPixelType*)ScreenBuffer, ImageSize) == GIF_ERROR){
					free(ScreenBuffer);
					ret = LIB_ERR;
					err = -1;
					goto gif_Error;
				}
			}
			free(ScreenBuffer);
			ScreenBuffer = NULL;
			if (GifFile->Image.ColorMap) cormap = 1;
			ColorMap = (GifFile->Image.ColorMap ? GifFile->Image.ColorMap : GifFile->SColorMap);
			if (colorCount<ColorMap->ColorCount){
				colorCount = ColorMap->ColorCount;				// gppbg
			}
			FreeMapObject(GifFile->Image.ColorMap);				//
			GifFile->Image.ColorMap = NULL;						// [JJ[}bvɂ郁[N΍
			break;
		case EXTENSION_RECORD_TYPE:
			if (DGifGetExtension(GifFile, &ExtCode, &Extension) == GIF_ERROR){
				ret = LIB_ERR;
				err = -1;
				goto gif_Error;
			}
			while (Extension != NULL) {
				if (DGifGetExtensionNext(GifFile, &Extension) == GIF_ERROR){
					ret = LIB_ERR;
					err = -1;
					goto gif_Error;
				}
			}
			break;
		case TERMINATE_RECORD_TYPE:
			break;
		default:
			break;
		}
		sceKernelDelayThread(5000);								// 5ms~iBGMXbh쓮pj
	} while (RecordType != TERMINATE_RECORD_TYPE);
	imgCount = GifFile->ImageCount;								// 摜i擾邽߂ɂǂقǋJƂ( j
	if (info){
		sprintf(info, "t@CTCY %dKB\n摜TCY X=%d Y=%d\nJ[ %d\nColorMap %d\n摜 %d",
		              (int)length/1024, GifFile->Image.Width, GifFile->Image.Height, colorCount, cormap, imgCount);
	}
	DGifCloseFile(GifFile);
	gif_buf.data = (unsigned char*)data;
	gif_buf.length = length;
	gif_buf.offset = 0;
	if ((GifFile = DGifOpen(&gif_buf, gif_data_read_func)) == NULL)
	{
		ret = LIB_ERR;
		err = -1;
		goto gif_Error;
	}
	SWidth = GifFile->SWidth;
	SHeight = GifFile->SHeight;
	Size = GifFile->SWidth * sizeof(GifPixelType);/* Size in bytes one row.*/
	// Gu]̂1s16oCgEɂ낦
	width2 = (GifFile->SWidth + 15) & 0xFFFFFFF0;
	ScreenBuffer = memalign(16, GifFile->SHeight * sizeof(GifRowType *));	// pbgC[W̊eC擪ʒu
	if (!ScreenBuffer)
	{
		ret = MEM_ERR;
		err = -1;
		goto gif_Error;
	}
	ImgBuf = memalign(16, Size * GifFile->SHeight);				// pbgC[W̎
	if (!ImgBuf)
	{
		ret = MEM_ERR;
		err = -1;
		goto gif_Error;
	}
	img = memalign(16, sizeof(unsigned char *) * GifFile->SHeight);	// ʃC[W̊eC擪ʒu
	if (!img)
	{
		ret = MEM_ERR;
		err = -1;
		goto gif_Error;
	}
	buf = memalign(16, 4 * width2 * GifFile->SHeight);			// ʃC[W̎
	if (!buf)
	{
		ret = MEM_ERR;
		err = -1;
		goto gif_Error;
	}
	for (i = 0; i < GifFile->SHeight; i++)
	{
		ScreenBuffer[i] = &ImgBuf[i * Size];					// pbgC[W̃CʒuƎ̂Ƃ̊֌Wڑ
		img[i] = &buf[i * 4 * width2];							// ʃC[W̃CʒuƎ̂Ƃ̊֌Wڑ
	}
	for (i = 0; i < GifFile->SWidth; i++)  /* Set its color to BackGround. */
	{
		ScreenBuffer[0][i] = GifFile->SBackGroundColor;			// PsڂwiFœhԂ
	}
	for (i = 1; i < GifFile->SHeight; i++)						// PsڂQsڈȍ~ɃRs[ăpbgC[WwiF
	{
		memcpy(ScreenBuffer[i], ScreenBuffer[0], Size);
		sceKernelDelayThread(50);								// 0.05ms~iBGMXbh쓮pj
	}
	if (imgCount!=0){											// ̉摜܂܂Ăꍇ
		gif = malloc(sizeof(struct strGif) * imgCount);
		err = 0;
		if (gif){
			for (i=0; i<imgCount ;i++){							// Ƀobt@̈mۂĂ
				gif[i].ImgBuf = memalign(16, Size * GifFile->SHeight);	// pbgC[W̕ۑp̈
				if (gif[i].ImgBuf == NULL){
					err = -1;
					break;
				}
				gif[i].Colors = malloc(colorCount * sizeof(GifColorType));
				if (gif[i].Colors == NULL){
					free(gif[i].ImgBuf);
					err = -1;
					break;
				}
			}
			if (err){											// Ȃ
				for (i=i-1; i>0 ;i--){
					free(gif[i].Colors);
					free(gif[i].ImgBuf);
				}
				free(gif);
				gif = NULL;
			}
		}
	}
	err = 0;

	/* Scan the content of the GIF file and load the image(s) in: */
	reset = 1;													// 摜\ʒũZbgw
	frameCnt = 0;
	nextTime = clock();
	do {
		do {
			if (DGifGetRecordType(GifFile, &RecordType) == GIF_ERROR)
			{
				ret = LIB_ERR;
				err = -1;
				goto gif_Error;
			}
			switch (RecordType)
			{
			case IMAGE_DESC_RECORD_TYPE:
				if (frameCnt>imgCount){							// \摜I
					ret = LIB_ERR;
					err = -1;
					goto gif_Error;
				}
				if (DGifGetImageDesc(GifFile) == GIF_ERROR)
				{
					ret = LIB_ERR;
					err = -1;
					goto gif_Error;
				}
				Row = GifFile->Image.Top; /* Image Position relative to Screen. */
				Col = GifFile->Image.Left;
				Width = GifFile->Image.Width;
				Height = GifFile->Image.Height;
				if (GifFile->Image.Left + GifFile->Image.Width > GifFile->SWidth ||
				   GifFile->Image.Top + GifFile->Image.Height > GifFile->SHeight)
				{
					ret = SUP_ERR;
					err = -1;
					goto gif_Error;
				}
				if (GifFile->Image.Interlace) {
					/* Need to perform 4 passes on the images: */
					for (Count = i = 0; i < 4; i++)
					{
						for (j = Row + InterlacedOffset[i]; j < Row + Height; j += InterlacedJumps[i])
						{
							if (DGifGetLine(GifFile, &ScreenBuffer[j][Col], Width) == GIF_ERROR)
							{
								ret = LIB_ERR;
								err = -1;
								goto gif_Error;
							}
						}
					}
				}
				else {
					for (i = 0; i < Height; i++)
					{
						if (DGifGetLine(GifFile, &ScreenBuffer[Row++][Col], Width) == GIF_ERROR)
						{
							ret = LIB_ERR;
							err = -1;
							goto gif_Error;
						}
					}
				}
				ColorMap = (GifFile->Image.ColorMap ? GifFile->Image.ColorMap : GifFile->SColorMap);
				if (ColorMap == NULL)
				{
					ret = SUP_ERR;
					err = -1;
					goto gif_Error;
				}
				if (gif){										// C[Wobt@mۂĂȂ
					memcpy(gif[frameCnt].ImgBuf, ImgBuf, Size * GifFile->SHeight);									// pbgC[Wۑ
					memcpy(gif[frameCnt].Colors, ColorMap->Colors, ColorMap->ColorCount * sizeof(GifColorType));	// pbge[uۑ
					frameCnt++;
				} else {										// C[Wobt@mۂĂȂ̂ŉ摜̕\s
					for (i = 0; i < SHeight; i++) {				// pbgC[Wx^摜
						GifRow = ScreenBuffer[i];
						BufferP = img[i];
						for (j = 0; j < SWidth; j++) {
							if (GifRow[j] != transparent)
							{
								ColorMapEntry = &ColorMap->Colors[GifRow[j]];
								*BufferP++ = ColorMapEntry->Red;
								*BufferP++ = ColorMapEntry->Green;
								*BufferP++ = ColorMapEntry->Blue;
								*BufferP++ = 0xFF;
							}
							else
								BufferP += 4;
						}
					}
					do{											// w肳ꂽt[ԂɂȂ܂őҋ@
						oldClock = clock();
						ret = psp2chImageViewer2((int**)img, SWidth, SHeight, menu, thumbFlag, &reset, shift, &pv, info, FData, thumbData);
						if (ret!=10){							// L[͂ɂ蒆f
							err = -1;
							goto gif_Error;
						}
						if (oldClock>clock()) break;			// NbNJEgI[o[t[ꍇ̑΍
					}while (clock()<nextTime && !gExitRequest);
				}
				FreeMapObject(GifFile->Image.ColorMap);			//
				GifFile->Image.ColorMap = NULL;					// [JJ[}bvɂ郁[N΍
				break;
			case EXTENSION_RECORD_TYPE:
				/* Skip any extension blocks in file: */
				if (DGifGetExtension(GifFile, &ExtCode, &Extension) == GIF_ERROR)
				{
					ret = LIB_ERR;
					err = -1;
					goto gif_Error;
				}
				if (ExtCode == GRAPHICS_EXT_FUNC_CODE)
				{
					int flag = Extension[1];
					transparent = (flag & 0x01) ? Extension[4] : -1;	// ߐF
					delaytime = Extension[2] + Extension[3] * 256;		// x
					nextTime = clock() + delaytime * 10*1000;			// ̃t[掞
					if (frameCnt>imgCount){								// \摜I
						ret = LIB_ERR;
						err = -1;
						goto gif_Error;
					}
					if (gif){
						gif[frameCnt].transparent = transparent;
						gif[frameCnt].delaytime = delaytime;
					}
				}
				while (Extension != NULL)
				{
					if (DGifGetExtensionNext(GifFile, &Extension) == GIF_ERROR)
					{
						ret = LIB_ERR;
						err = -1;
						goto gif_Error;
					}
				}
				break;
			case TERMINATE_RECORD_TYPE:
				break;
			default:			/* Should be traps by DGifGetRecordType. */
				break;
			}
		} while (RecordType != TERMINATE_RECORD_TYPE);
		if (gif==NULL && imgCount>1){
			DGifCloseFile(GifFile);
			gif_buf.data = (unsigned char*)data;
			gif_buf.length = length;
			gif_buf.offset = 0;
			if ((GifFile = DGifOpen(&gif_buf, gif_data_read_func)) == NULL){
				ret = LIB_ERR;
				err = -1;
			}
		}
		if(sceCtrlPeekBufferPositive(&s2ch.pad, 1)){
			if (s2ch.pad.Buttons != s2ch.oldPad.Buttons){
				s2ch.oldPad = s2ch.pad;
				if(s2ch.pad.Buttons & PSP_CTRL_CROSS){			// ~ɂ钆f
					ret = SAVE_ERR;
					err = -1;
				}
			}
		}
		sceKernelDelayThread(5000);								// 5ms~iBGMXbh쓮pj
	} while (!gExitRequest && !err && gif==NULL && imgCount>1);

gif_Error:
	DGifCloseFile(GifFile);

	if (err==0){												// G[NĂȂȂ
		frameCnt = 0;
		if (imgCount==1){										// 摜P̂Ƃ
			for (i = 0; i < SHeight; i++){						// pbgC[Wx^摜
				GifRow = &gif[frameCnt].ImgBuf[i*Size];
				BufferP = img[i];
				for (j = 0; j < SWidth; j++) {
					if (GifRow[j] != gif[frameCnt].transparent)
					{
						ColorMapEntry = &gif[frameCnt].Colors[GifRow[j]];
						*BufferP++ = ColorMapEntry->Red;
						*BufferP++ = ColorMapEntry->Green;
						*BufferP++ = ColorMapEntry->Blue;
						*BufferP++ = 0xFF;
					}
					else
						BufferP += 4;
				}
			}
			ret = psp2chImageViewer((int**)img, SWidth, SHeight, menu, thumbFlag, shift, info, FData, thumbData);

		} else if (gif){										// 摜ŃC[Wobt@mۂĂȂ
			do{													// 摜\[v
				for (i = 0; i < SHeight; i++){					// pbgC[Wx^摜
					GifRow = &gif[frameCnt].ImgBuf[i*Size];
					BufferP = img[i];
					for (j = 0; j < SWidth; j++) {
						if (GifRow[j] != gif[frameCnt].transparent)
						{
							ColorMapEntry = &gif[frameCnt].Colors[GifRow[j]];
							*BufferP++ = ColorMapEntry->Red;
							*BufferP++ = ColorMapEntry->Green;
							*BufferP++ = ColorMapEntry->Blue;
							*BufferP++ = 0xFF;
						}
						else
							BufferP += 4;
					}
				}
				nextTime = clock() + gif[frameCnt].delaytime * 10*1000;	// ̃t[\鎞
				do{												// t[掞Ԃ܂Ń[v
					oldClock = clock();
					ret = psp2chImageViewer2((int**)img, SWidth, SHeight, menu, thumbFlag, &reset, shift, &pv, info, FData, thumbData);
					if (ret!=10) break;							// L[͂ɂ蒆f
					if (oldClock>clock()) break;				// NbNJEgI[o[t[ꍇ̑΍
				}while (clock()<nextTime && !gExitRequest);
				frameCnt++;
				if (frameCnt>=imgCount) frameCnt = 0;
			}while (!gExitRequest && ret==10);
		}
	}

	if (gif){													// C[Wobt@J
		for (i=imgCount-1; i>=0 ;i--){
			free(gif[i].ImgBuf);
			free(gif[i].Colors);
		}
		free(gif);
	}
	if (buf)
		free(buf);
	if (img)
		free(img);
	if (ImgBuf)
		free(ImgBuf);
	if (ScreenBuffer)
		free(ScreenBuffer);
	return ret;
}

//==============================================================
// 摜\
//--------------------------------------------------------------
// file      : 摜t@Cւ̃tpX
// FData     : t@C
// menu      : j[ON/OFF(0:OFF)
// thumbFlag : 摜\TCY
// type      : 摜`
//--------------------------------------------------------------

int psp2chMenuImageView(char* file, FileData *FData, int *menu, int *thumbFlag, int type)
{
	SceIoStat	st;
	strThumb	thumbData;
	char	*p, msg[512], info[512], thumbPath[1024];
	int		ret = 0, size, pos;

	strcpy(msg, "WJ...(");
	if (s2ch.cfg.hbl){
		psp2chUTF82Sjis( info, file );
	} else {
		strcpy( info, file );
	}
	strcat( msg, info );
	strcat( msg, ")" );
	if_clipText( info, msg, 460, 0.7f);
	guStart();
	if (*thumbFlag == -1) {
		if_printSjis( 5, 32, info, 0.7f, 0xFFFFFF, 0x101010, 0.7f );
	} else {
		if_printSjis( 5, 16, info, 0.7f, 0xFFFFFF, 0x101010, 0.7f );
	}

	sceGuFinish();
	flipScreen(0);

	SceUID fd = sceIoOpen( file, PSP_O_RDONLY, FILE_PARMISSION );
	if (fd < 0) {
		psp2chNormalError( FILE_OPEN_ERR, file );
		return -1;
	}
	size = FData->size;
	char *image = (char*)malloc(sizeof(char) * (size + 1));
	if (image) {
		sceIoRead( fd, image, size );
	}
	sceIoClose(fd);
	if (!image) {
		MessageDialogText( "摜t@C̓ǂݍ݂ɕKvȃ̊mۂɎs܂\n%s\nTCY:%d", file, size );
		return -1;
	}

	p = strchr( file, ':' );
	if (p) {													// hCu^[Ȃ
		pos = p - file + 1;
		strncpy( thumbPath, file, pos );
		thumbPath[pos] = '/';
		thumbPath[pos+1] = '\0';
		strcat( thumbPath, THUMBFOLDER );						// TlCtH_
		strcat( thumbPath, &file[pos] );
		strcat( thumbPath, ".dat" );							// TlCۑĂnỸtH_
	} else {													// hCu^[Ȃi肦Ȃ͂j
		thumbPath[0] = '\0';
	}
	thumbData.path = thumbPath;									// TlCۑtpX
	sceIoGetstat( file, &st );
	thumbData.time = st.st_mtime;								// 摜̍XV
	info[0] = '\0';
	switch(type)
	{
		case 0:
			ret = psp2chImageViewJpeg( image, size, menu, thumbFlag, 1, info, FData, thumbData );
			break;
		case 1:
			ret = psp2chImageViewPng( image, size, menu, thumbFlag, 1, info, FData, thumbData );
			break;
		case 2:
			ret = psp2chImageViewGif( image, size, menu, thumbFlag, 1, info, FData, thumbData );
			break;
		case 3:
			ret = psp2chImageViewBmp( image, size, menu, thumbFlag, 1, info, FData, thumbData );
			break;
	}
	if (ret < 0){
		strcpy( msg,"decompress error\n" );
		switch (ret){
		case LIB_ERR:
			strcat( msg, "  摜tH[}bgsł" );
			break;
		case MEM_ERR:
			strcat( msg, "  mۂł܂ł" );
			break;
		case SUP_ERR:
			strcat( msg, "  T|[gĂȂ摜`ł" );
			break;
		case FRM_ERR:
			strcat( msg, "  摜܂" );
			break;
		}
		strcat( msg, "\n\n" );
		strcat( msg, info );
		MessageDialogText(msg);
	}
	free(image);
	return ret;
}
