//==============================================================
// miniunz.c
// Version 1.01b, May 30th, 2004
//
// Copyright (C) 1998-2004 Gilles Vollant
// 2010-2011 STEAR freeze viewerpɂȂC܂
//--------------------------------------------------------------

#define unix

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <errno.h>
#include <fcntl.h>
#include <malloc.h>
#include <pspiofilemgr.h>
#include <pspdisplay.h>
#include <pspdebug.h>
#include <pspctrl.h>

#include "FreezeViewer.h"
#include "fileList.h"
#include "psp2ch.h"
#include "charConv.h"
#include "unzip.h"

extern S_2CH		s2ch;				// psp2ch.c
extern volatile int	gFileCtrlEnd;		// fileList.c

#define CASESENSITIVITY (0)
#define WRITEBUFFERSIZE (64 * 1024)								// WJɎgpő僁
#define MAXFILENAME (256)


//==============================================================
// change the date/time of a file
//--------------------------------------------------------------
// filename : the filename of the file where date/time must be modified
// tmu_date : the SAME new date at the tm_unz format
//--------------------------------------------------------------

void change_file_date(const char *filename, tm_unz tmu_date)
{
	SceIoStat		st;
	ScePspDateTime	st_time;

	memset(&st, 0, sizeof(st));
	st.st_mode = 0777;
	st.st_attr = FIO_SO_IFREG;
	st_time.microsecond = 0;
	st_time.second      = tmu_date.tm_sec;
	st_time.minute      = tmu_date.tm_min;
	st_time.hour        = tmu_date.tm_hour;
	st_time.day         = tmu_date.tm_mday;
	st_time.month       = tmu_date.tm_mon;
	st_time.year        = tmu_date.tm_year;
	st.st_ctime = st_time;
	st.st_atime = st_time;
	st.st_mtime = st_time;
	sceIoChstat( filename, &st, FIO_S_IRWXU | FIO_S_IRWXG | FIO_S_IRWXO );
}


//==============================================================
// pX[hg
//--------------------------------------------------------------

int usePassword = 0;

void SetUsepassword(int p)
{
	usePassword = p;
}

int GetUsePassword()
{
	return usePassword;
}

//==============================================================
// tH_
//--------------------------------------------------------------
// itH_xɐ܂B
//--------------------------------------------------------------

static int mymkdir(char *dirname)
{
	return sceIoMkdir( dirname, 0777 );
}

int makedir(char *newdir)
{
	char *buffer;
	char *p;
	int  len = (int)strlen(newdir);

	if (len <= 0)
		return 0;

	buffer = (char*)malloc(len+1);
	strcpy(buffer,newdir);

	if (buffer[len-1] == '/') {
		buffer[len-1] = '\0';
	}
	if (mymkdir(buffer) == 0)
	{
		free(buffer);
		return 1;
	}

	p = buffer+1;
	while (1)
	{
		char hold;

		while(*p && *p != '\\' && *p != '/')
			p++;
		hold = *p;
		*p = 0;
		if ((mymkdir(buffer) == -1) && (errno == ENOENT))
		{
			free(buffer);
			return 0;
		}
		if (hold == 0)
			break;
		*p++ = hold;
	}
	free(buffer);
	return 1;
}

//==============================================================

void do_banner()
{
	printf("AnonymousTipster's .zip plugin, based on:\n");
    printf("MiniUnz 1.01b, demo of zLib + Unz package written by Gilles Vollant\n");
    printf("more info at http://www.winimage.com/zLibDll/unzip.html\n\n");
}

//==============================================================

int do_list(unzFile uf)
{
    uLong i;
    unz_global_info gi;
    int err;

    err = unzGetGlobalInfo (uf,&gi);
    if (err!=UNZ_OK)
        printf("error %d with zipfile in unzGetGlobalInfo \n",err);
    printf(" Length  Method   Size  Ratio   Date    Time   CRC-32     Name\n");
    printf(" ------  ------   ----  -----   ----    ----   ------     ----\n");
    for (i=0;i<gi.number_entry;i++)
    {
        char filename_inzip[256];
        unz_file_info file_info;
        uLong ratio=0;
        const char *string_method;
        char charCrypt=' ';
        err = unzGetCurrentFileInfo(uf,&file_info,filename_inzip,sizeof(filename_inzip),NULL,0,NULL,0);
        if (err!=UNZ_OK)
        {
            printf("error %d with zipfile in unzGetCurrentFileInfo\n",err);
            break;
        }
        if (file_info.uncompressed_size>0)
            ratio = (file_info.compressed_size*100)/file_info.uncompressed_size;

        /* display a '*' if the file is crypted */
        if ((file_info.flag & 1) != 0)
            charCrypt='*';

        if (file_info.compression_method==0)
            string_method="Stored";
        else
        if (file_info.compression_method==Z_DEFLATED)
        {
            uInt iLevel=(uInt)((file_info.flag & 0x6)/2);
            if (iLevel==0)
              string_method="Defl:N";
            else if (iLevel==1)
              string_method="Defl:X";
            else if ((iLevel==2) || (iLevel==3))
              string_method="Defl:F"; /* 2:fast , 3 : extra fast*/
        }
        else
            string_method="Unkn. ";

        printf("%7lu  %6s%c%7lu %3lu%%  %2.2lu-%2.2lu-%2.2lu  %2.2lu:%2.2lu  %8.8lx   %s\n",
                file_info.uncompressed_size,string_method,
                charCrypt,
                file_info.compressed_size,
                ratio,
                (uLong)file_info.tmu_date.tm_mon + 1,
                (uLong)file_info.tmu_date.tm_mday,
                (uLong)file_info.tmu_date.tm_year % 100,
                (uLong)file_info.tmu_date.tm_hour,(uLong)file_info.tmu_date.tm_min,
                (uLong)file_info.crc,filename_inzip);
        if ((i+1)<gi.number_entry)
        {
            err = unzGoToNextFile(uf);
            if (err!=UNZ_OK)
            {
                printf("error %d with zipfile in unzGoToNextFile\n",err);
                break;
            }
        }
    }

    return 0;
}


//==============================================================
// t@CWJ
//--------------------------------------------------------------
// ufFzipt@C
// popt_extract_without_pathF0    pXČ
//                            ȊO pX\͖
// password
// info : G[̃O
//--------------------------------------------------------------

int do_extract_currentfile(uf, popt_extract_without_path, password, entry, info)
	unzFile		uf;
	const int*	popt_extract_without_path;
	const char*	password;
	int			entry;
	char		*info;
{
	char			filename_inzip[1024], filename_inzip_sjis[1024];
	char			*filename_withoutpath, *write_filename;
	char			*p;
	int				i, err = UNZ_OK, skip = 0;
	SceUID			fout;
	u8				*buf;
	uInt			size_buf;
	unz_file_info	file_info;

	err = unzGetCurrentFileInfo(uf, &file_info, filename_inzip, sizeof(filename_inzip), NULL, 0, NULL, 0);
	if (err!=UNZ_OK) {
		sprintf(info, "%s\nzipt@C̏񂪎擾ł܂ł\nizipt@CĂHj", filename_inzip);
		return err;
	}
	sceKernelDelayThread(5000);									// 5ms~đ̃Xbh𓮂

	strcpy(filename_inzip_sjis, filename_inzip);				// ʕ\p
	if (s2ch.cfg.hbl){											// HBLł̓t@C̃VtgJISUTF8ϊs
		psp2chSjis2UTF8(filename_inzip, filename_inzip);
	}

	size_buf = WRITEBUFFERSIZE;
	for (i=0; i<4; i++) {										// WRITEBUFFERSIZE`͈̔͂ŏo邾傫ȍƈmۂ
		buf = (void*)malloc(size_buf);
		if (buf) break;											// mۂł烋[vI
		size_buf = size_buf >> 1;
	}
	if (buf==NULL) {											// ǃmۂoȂ
		sprintf(info, "Ɨp̎擾Ɏs܂");
		return UNZ_INTERNALERROR;
	}

	p = filename_withoutpath = filename_inzip;
	while ((*p) != '\0') {										// pX̍Ō'/''\'T
		if (((*p)=='/') || ((*p)=='\\'))
			filename_withoutpath = p+1;
		p++;
	}
	if ((*filename_withoutpath)=='\0') {						// pX'/''\'ŏIĂȂ
		if ((*popt_extract_without_path)==0) {
			mymkdir(filename_inzip);							// tH_
		}
	} else {													// t@CWJ
		if ((*popt_extract_without_path)==0) {
			write_filename = filename_inzip;					// pXtt@C
		} else {
			write_filename = filename_withoutpath;				// t@Ĉ
		}

		if (usePassword == 1) {
			err = unzOpenCurrentFilePassword(uf,password);
		} else {
			err = unzOpenCurrentFilePassword(uf,NULL);
		}
		if (err!=UNZ_OK){
			sprintf( info, "%s\nWJɎs܂\nizipt@CĂHj", filename_inzip_sjis );
		}

		if ((skip==0) && (err==UNZ_OK)) {						// fBNg\\z
			fout = sceIoOpen(write_filename, O_RDWR, 0777);
			/* some zipfile don't contain directory alone before file */
			if ((fout<=0) && ((*popt_extract_without_path)==0) &&
			                    (filename_withoutpath!=(char*)filename_inzip))
			{
				char c = *(filename_withoutpath-1);
				*(filename_withoutpath-1) = '\0';
				makedir(write_filename);
				*(filename_withoutpath-1) = c;
				fout = sceIoOpen(write_filename, O_RDWR, 0777);
			}
			sceIoClose(fout);
		}

		fout = sceIoOpen(write_filename, O_RDWR | O_CREAT, 0777);
		if (fout > 0) {
			do {												// Jgt@CWJۑ
				err = unzReadCurrentFile(uf, buf, size_buf);
				if (err<0) {
					sprintf( info, "t@C̓WJɎs܂\nipX[hԈĂHj" );
					break;
				}
				if (err>0) {
					if (sceIoWrite(fout,buf,err)!=err) {
						sprintf(info, "%s\nt@Cւ݂̏Ɏs܂\nifBXNeʂȂHj", filename_inzip_sjis);
						err = UNZ_ERRNO;
						break;
					}
				}
				sceKernelDelayThread(5000);						// 5ms~đ̃Xbh𓮂
			} while (err>0);
			sceIoClose(fout);
			if (err==0) {										// WJIt@C
				change_file_date( write_filename, file_info.tmu_date );
			}

		} else {
			sprintf(info, "%s\nt@C̍쐬Ɏs܂", write_filename);
		}

		if (err==UNZ_OK) {
			err = unzCloseCurrentFile(uf);
			if (err!=UNZ_OK) {									// CRC Error\
				sprintf(info, "%s is CRC Error\nizipt@CĂcHj\n", filename_inzip_sjis);
			}
		} else {
			unzCloseCurrentFile(uf);		/* don't lose the error */
		}
    }

	free(buf);
	return err;
}

//==============================================================
// A[JCuɊ܂܂SẴt@CWJ
//--------------------------------------------------------------
// <t@CXbh>s܂B
//--------------------------------------------------------------

int do_extract(uf, opt_extract_without_path, password, info)
	unzFile		uf;
	int			opt_extract_without_path;
	const char*	password;
	char		*info;
{
	uLong			i;
	unz_global_info	gi;
	int				err;

	err = unzGetGlobalInfo(uf, &gi);
	if (err!=UNZ_OK) {
		sprintf(info, "zipt@C擾ł܂ł");
		return err;
	}

	gFCdata.progMax = gi.number_entry;
	gFCdata.progPos = 0;
	for (i=0; i<gi.number_entry; i++) {
		gFCdata.progPos++;
		err = do_extract_currentfile(uf, &opt_extract_without_path, password, gi.number_entry, info);
		if (err != UNZ_OK) break;
		if (gFileCtrlEnd) break;								// fv

		if ((i+1)<gi.number_entry) {
			err = unzGoToNextFile(uf);
			if (err!=UNZ_OK) {
				sprintf(info, "WJrŃG[܂\nzipt@CĂH");
				break;
			}
		}
	}

	return err;
}

//==============================================================
// w肳ꂽ̃t@Ĉ݂WJ
//--------------------------------------------------------------

int do_extract_onefile(uf, filename, opt_extract_without_path, password)
	unzFile uf;
	const char* filename;
	int opt_extract_without_path;
	const char* password;
{
	if (unzLocateFile(uf,filename,CASESENSITIVITY)!=UNZ_OK) {
		return 2;
	}

	if (do_extract_currentfile(uf,&opt_extract_without_path,password) == UNZ_OK) {
		return 0;
	} else {
		return 1;
	}
}


//==============================================================
// zipt@CWJ
//--------------------------------------------------------------
// zippath Fzipt@Cւ̃tpX
// destpathFWJtH_
// pass    FpX[h
// info    FG[bZ[W
// ߂l  F0     I
//           0ȉ G[idestpathtH_ɈꕔWJĂj
//--------------------------------------------------------------
// destpathtH_zippathA[JCuWJB
//--------------------------------------------------------------

int unzipToDir(const char *zippath, const char *destpath, const char *pass, char *info)
{
	const char	*zipfilename = NULL;
	const char	*filename_to_extract = NULL;
	const char	*password = NULL;
	char		filename_try[MAXFILENAME+16] = "", folder[1024];
	int			opt_do_extract_withoutpath = 0;
	int			ret;
	char		dirname[1024];
    unzFile		uf = NULL;

	getcwd( folder,1024 );										// JgfBNg擾

	zipfilename = zippath;			//"ms0:/testzip.zip";
	strcpy( dirname, destpath );	//"ms0:/zext/";
	password = pass;
	if (strlen(password)==0) {									// pX[hw肳Ă邩
		SetUsepassword(0);
	} else {
		SetUsepassword(1);
	}

	if (zipfilename!=NULL) {
		strncpy(filename_try, zipfilename, MAXFILENAME-1);
		/* strncpy doesnt append the trailing NULL, of the string is too long. */
		filename_try[ MAXFILENAME ] = '\0';

		uf = unzOpen(zipfilename);
	}

	if (uf==NULL) {
		sprintf(info, "Cannot open %s", zipfilename);
		return 1;
	}

	if (s2ch.cfg.hbl) {											// HBLł̓t@C̃VtgJISUTF8ϊs
		psp2chSjis2UTF8( dirname, dirname );
	}

	if (chdir(dirname)) {
		sprintf(info, "Error changing into %s, aborting", dirname);
		unzClose(uf);
		return UNZ_INTERNALERROR;
	}

	if (filename_to_extract == NULL) {
		ret = do_extract(uf, opt_do_extract_withoutpath, password, info);
	} else {
		ret = do_extract_onefile(uf, filename_to_extract, opt_do_extract_withoutpath, password);
	}
	unzClose(uf);
	chdir(folder);												// JgfBNgɖ߂
	return ret;
}


//==============================================================
// zipt@C̃pX[h`FbN
//--------------------------------------------------------------
// zippathFzipt@Cւ̃tpX
// ߂lF-1:zipt@CJȂizipt@Cł͂ȂHj
//          0:pX[h͕KvȂ
//          1:pX[hKv
//--------------------------------------------------------------
// w肳ꂽzipt@CɃpX[h|Ă邩𒲂ׂ
//--------------------------------------------------------------

int unzipPass(const char *zippath)
{
	unzFile			uf;
	unz_file_info	file_info;
	unz_global_info	gi;
	char	filename_inzip[1024], buf[1024];
	int		i, ret, err, len;

	uf = unzOpen(zippath);
	if (uf == NULL) return -1;
	err = unzGetGlobalInfo(uf, &gi);
	if (err != UNZ_OK) {
		unzClose(uf);
		return -1;
	}

	ret = 0;
	for (i=0; i<gi.number_entry; i++) {							// ŏ̃t@CT
		ret = unzGetCurrentFileInfo(uf, &file_info, filename_inzip, sizeof(filename_inzip), NULL, 0, NULL, 0);
		len = strlen(filename_inzip);
		if (filename_inzip[len-1]!='/' && filename_inzip[len-1]!='\\') {
			err = unzOpenCurrentFilePassword( uf, NULL );
			if (err != UNZ_OK) {
				ret = -1;
				break;
			}
			err = unzReadCurrentFile( uf, buf, sizeof(buf) );
			if (err == -3) {									// pX[hœWJĂ݂ăG[ɂȂ
				ret = 1;										// pX[hKv
			}
			unzCloseCurrentFile(uf);
			break;
		}
		ret = unzGoToNextFile(uf);
		if (ret != UNZ_OK) {
			ret = -1;
			break;
		}
	}

	unzClose(uf);
	return ret;
}

